//----------------------------------------------------------------------------
// AnimatedFormEffect.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: AnimatedFormEffect.pas
//----------------------------------------------------------------------------
#ifndef AnimatedFormEffectHPP
#define AnimatedFormEffectHPP
//----------------------------------------------------------------------------
#include <Forms.hpp>
#include <Classes.hpp>
#include <Windows.hpp>
#include <System.hpp>
namespace Animatedformeffect
{
//-- type declarations -------------------------------------------------------
typedef float Real;

struct TMathPoint
{
	float X;
	float Y;
} ;

struct TMatrix
{
	float M11;
	float M12;
	float M13;
	float M21;
	float M22;
	float M23;
	float M31;
	float M32;
	float M33;
} ;

struct TSpikeData
{
	TMathPoint TriangleEnd[3][16];
	TMathPoint EndCenter[16];
	TMathPoint TriangleCenter[16];
	TMatrix MatrixCircle[16];
} ;

enum TAnimationType { atInit, atDraw, atErase };

enum TEffectType { etRandom, etSpin, etVortex, etScatterGather, etSpike, etFireworks };

class __declspec(delphiclass) TAnimatedFormEffect;
class __declspec(pascalimplementation) TAnimatedFormEffect : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	bool FAnimateOnShow;
	bool FAnimateOnHide;
	Byte FDelay;
	Byte FFrames;
	Byte FFireworkBlasts;
	TEffectType FEffectType;
	Byte FSteps;
	Classes::TNotifyEvent OldFormShow;
	Classes::TNotifyEvent OldFormHide;
	Forms::TForm* ParentForm;
	HDC DrawDC;
	float EffectParam;
	TMatrix GlobalMatrix;
	TMathPoint FireworksData[256];
	int AfterImages;
	int TotalSteps;
	int Step;
	TMathPoint RightTop;
	TMathPoint Center;
	TSpikeData SpikeData;
	TEffectType CurrentEffect;
	void __fastcall Animate(bool Open);
	void __fastcall AnimationSelect(TAnimationType AnimationType);
	void __fastcall efSpinFrame(TAnimationType AnimationType);
	void __fastcall efVortexFrames(TAnimationType AnimationType);
	void __fastcall efScatterGatherFrames(TAnimationType AnimationType);
	void __fastcall efSpikeFrames(TAnimationType AnimationType);
	void __fastcall efFireworxFrames(TAnimationType AnimationType);
	void __fastcall FormShow(System::TObject* Sender);
	void __fastcall FormHide(System::TObject* Sender);
	
public:
	__fastcall virtual TAnimatedFormEffect(Classes::TComponent* aOwner);
	virtual void __fastcall Loaded(void);
	void __fastcall Open(void);
	void __fastcall Close(void);
	
__published:
	__property bool AnimateOnShow = {read=FAnimateOnShow, write=FAnimateOnShow, nodefault};
	__property bool AnimateOnHide = {read=FAnimateOnHide, write=FAnimateOnHide, nodefault};
	__property Byte Delay = {read=FDelay, write=FDelay, nodefault};
	__property Byte FireworkBlasts = {read=FFireworkBlasts, write=FFireworkBlasts, nodefault};
	__property Byte Frames = {read=FFrames, write=FFrames, nodefault};
	__property TEffectType EffectType = {read=FEffectType, write=FEffectType, nodefault};
	__property Byte Steps = {read=FSteps, write=FSteps, nodefault};
public:
	/* TComponent.Destroy */ __fastcall virtual ~TAnimatedFormEffect(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
extern void __fastcall Register(void);

}	/* namespace Animatedformeffect */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Animatedformeffect;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// AnimatedFormEffect
